package matrices;

import java.awt.*;

public class LinearUtil {
    private LinearUtil() {
    }

    public static Vector3 normalize(Vector3 vector) {
        double x = vector.getX() / vector.getLength();
        double y = vector.getX() / vector.getLength();
        double z = vector.getZ() / vector.getLength();
        return new Vector3(x, y, z);
    }

    public static Vector3 cross(Vector3 vector1, Vector3 vector2) {
        double x = vector1.getY() * vector2.getZ() - vector1.getZ()
                * vector2.getY();
        double y = vector1.getZ() * vector2.getX() - vector1.getX()
                * vector2.getZ();
        double z = vector1.getX() * vector2.getY() - vector1.getY()
                * vector2.getX();
        return new Vector3(x, y, z);
    }

    public static void drawVector(Vector2 vector, Graphics2D g2, Color color) {
        float radius;
        double angle;
        radius = (float) vector.getLength();
        angle = MathUtil.radToDeg(vector.getAngle());
        float x0 = 800f;
        float y0 = 800f;
        Arrow ar = new Arrow(x0 / 2, (y0 - 30f) / 2f, radius * 30f, 1f,
                (float) angle, 15f, 10f, true);
        g2.setColor(color);
        g2.fill(ar);
        g2.setColor(Color.BLACK);
    }

    public static Vector2 add(Vector2 vector1, Vector2 vector2) {
        double x = vector1.getX() + vector2.getX();
        double y = vector1.getY() + vector2.getY();
        return new Vector2(x, y);
    }
}
