package matrices2;

import matrices.Matrix;
import matrices.MatrixException;

import java.util.concurrent.ForkJoinPool;
import java.util.concurrent.RecursiveTask;

public class Matrix073 extends RecursiveTask<Double> {
    private static final long serialVersionUID = 2613196985818202539L;
    private final String path;

    public Matrix073(String path) {
        this.path = path;
    }

    @Override
    protected Double compute() {
        Matrix matrix = new Matrix(path);
        Double det = null;
        try {
            det = matrix.det();
        } catch (MatrixException e) {
            e.printStackTrace();
        }
        return det;
    }

    public static void main(String[] args) {
        ForkJoinPool pool = new ForkJoinPool();
        Matrix073 task = new Matrix073("matrices/assets/matrix6.txt");
        double det = pool.invoke(task);
        System.out.println(det);
    }
}
