package matrices2;

import matrices.Matrix;
import matrices.MatrixUtil;

import java.util.concurrent.ForkJoinPool;
import java.util.concurrent.RecursiveTask;

public class Matrix074 extends RecursiveTask<Matrix> {
    private static final long serialVersionUID = 2613196985818202539L;
    private final String path1;
    private final String path2;

    public Matrix074(String path1, String path2) {
        this.path1 = path1;
        this.path2 = path2;
    }

    @Override
    protected Matrix compute() {
        Matrix matrix1 = new Matrix(path1);
        Matrix matrix2 = new Matrix(path2);
        return MatrixUtil.multiply3(matrix1, matrix2);
    }

    public static void main(String[] args) {
        ForkJoinPool pool = new ForkJoinPool();
        Matrix074 task = new Matrix074("matrices/assets/matrix6.txt",
                "matrices/assets/matrix6.txt");
        Matrix mat = pool.invoke(task);
        mat.printToConsole();
    }
}
